import Block from "../block.js";
import PlaceholdeStatement from "../statements/placeholder-statement.js";
export default function placeholderFactory(key, value, observables, factory) {
    return () => {
        const block = new Block();
        const activator = (parent, host, scope, directives) => {
            parent.insertBefore(block.start, block.end);
            const context = {
                block,
                directives,
                factory,
                host,
                key,
                observables,
                parent,
                scope,
                value,
            };
            return new PlaceholdeStatement(context);
        };
        return [block.end, activator];
    };
}
