import observe from "../observe.js";
export default function textNodeFactory(expression, observables) {
    return () => {
        const node = document.createTextNode("");
        const activator = (_parent, _host, scope) => {
            const listener = () => void (node.nodeValue = expression(scope));
            const subscription = observe(scope, observables, listener, false);
            return { dispose: () => subscription.unsubscribe() };
        };
        return [node, activator];
    };
}
