import type { IDisposable } from "@surface/core";
import type { DirectiveEntry } from "../../types/index";
import Block from "../block.js";
import type Expression from "../types/expression";
import type Factory from "../types/fatctory";
import type ObservablePath from "../types/observable-path";
import type Pattern from "../types/pattern";
declare type Context = {
    block: Block;
    directives: Map<string, DirectiveEntry>;
    factory: Factory;
    host: Node;
    left: Pattern;
    observables: ObservablePath[];
    operator: "in" | "of";
    parent: Node;
    right: Expression;
    scope: object;
};
export default class LoopStatement implements IDisposable {
    private readonly context;
    private static readonly maximumAmount;
    private readonly cache;
    private readonly cancellationTokenSource;
    private readonly iterator;
    private readonly subscription;
    private readonly tree;
    private disposed;
    constructor(context: Context);
    private action;
    private forOfIterator;
    private forInIterator;
    private readonly task;
    dispose(): void;
}
export {};
