import { stringToCSSStyleSheet } from "../common.js";
import StaticMetadata from "../metadata/static-metadata.js";
/**
 * Styles adopted by the shadow root.
 * @param styles Styles.
 */
export default function styles(...styles) {
    return (constructor) => {
        StaticMetadata.from(constructor).styles.push(...styles.map(stringToCSSStyleSheet));
        return constructor;
    };
}
