import type { IDisposable } from "@surface/core";
import type PlaceholderDirectiveDescriptor from "../types/placeholder-directive-descriptor";
import type TemplateDirectiveContext from "../types/template-directive-context.js";
export default class PlaceholderDirective implements IDisposable {
    private readonly cancellationTokenSource;
    private readonly context;
    private readonly descriptor;
    private readonly keySubscription;
    private readonly metadata;
    private readonly template;
    private readonly templateBlock;
    private currentDisposable;
    private disposed;
    private key;
    private lazyInjectionCancellationTokenSource;
    private subscription;
    private injectionContext?;
    constructor(template: HTMLTemplateElement, descriptor: PlaceholderDirectiveDescriptor, context: TemplateDirectiveContext);
    private readonly applyInjection;
    private readonly applyLazyInjection;
    private readonly inject;
    private readonly onKeyChange;
    private readonly task;
    private readonly defaultTask;
    dispose(): void;
}
