import { disposeTree as disposeTreeSync } from "./common.js";
import Scheduler from "./processors/scheduler.js";
export const globalCustomDirectives = new Map();
export const scheduler = new Scheduler(16.17);
/** Deeply disposes a node tree. */
export function disposeTree(node) {
    void scheduler.enqueue(() => disposeTreeSync(node), "low");
}
/** Returns a promise that will be resolved when all scheduled updated was executed. */
export async function painting() {
    return scheduler.execution();
}
